function Trig=LoadTrig(BaseName)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

Trig.Coords = load(sprintf('%s.pts',BaseName));
Trig.Facets = load(sprintf('%s.tri',BaseName))+1;
%Trig.FixIds = LoadIfExists(sprintf('%s.fix',BaseName));

Trig.NVerts = size(Trig.Coords,1);
Trig.NFacets= size(Trig.Facets,1);

%Trig.Neighbors = NeighborhoodFromNodes(Trig.Facets,Trig.NVerts);
Trig.Edges  = GetEdges(Trig);

function Neighborhood = NeighborhoodFromNodes(Nodes,nPts)

Neighborhood = zeros(nPts,nPts);
for i=1:size(Nodes,1)
    Neighborhood(Nodes(i,1),Nodes(i,2)) = 1;
    Neighborhood(Nodes(i,1),Nodes(i,3)) = 1;
    Neighborhood(Nodes(i,2),Nodes(i,1)) = 1;
    Neighborhood(Nodes(i,2),Nodes(i,3)) = 1;
    Neighborhood(Nodes(i,3),Nodes(i,1)) = 1;
    Neighborhood(Nodes(i,3),Nodes(i,2)) = 1;
end

function Edges=GetEdges(Trig)
    
Neighbors=NeighborhoodFromNodes(Trig.Facets,Trig.NVerts);
Edges=[];
for j=1:Trig.NVerts
    for i=1:j-1
        if(Neighbors(i,j))
            Edges=[Edges,[i;j]];
        end
    end
end