function Trig = computeVertexNormals(Trig)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

Trig.Vertex_Normal = zeros(Trig.NVerts,3);

for i = 1 : Trig.NVerts
    
    fids = getFacetsForVertex(Trig,i);
    
    a = mean(Trig.Facet_Normal(fids(:,1),1));
    b = mean(Trig.Facet_Normal(fids(:,1),2));
    c = mean(Trig.Facet_Normal(fids(:,1),3));
        
    n = [a b c];
    
    Trig.Vertex_Normal(i,:) = n / norm(n);
        
end