function displayDefModes(xyz0,modes,weight)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

m = size(modes,2);
N = length(xyz0);
xyz00 = xyz0(:);

if(nargin<3)
    weight = 100;
end

%stop = 0;
%i = 1;

figure;
%while (i<=m && stop==0)
for i = 1 : m
   clf;
   hold on;
   temp = modes(:,i)*weight;
   xyz1 = xyz00 + temp(:);
   xyz2 = xyz00 - temp(:);
   %plot3(xyz00(1:3:end),xyz00(2:3:end),xyz00(3:3:end),'r.'); 
   plot3(xyz1(1:3:end),xyz1(2:3:end),xyz1(3:3:end),'g.');
   plot3(xyz2(1:3:end),xyz2(2:3:end),xyz2(3:3:end),'b.');
   axis equal;
   title(sprintf('def. mode %d',i));
   pause;
%    k = waitforbuttonpress;
%    if(k==1)
%        stop = 1;
%    else
%        stop = 0;
%    end
%   i = i + 1;
end
