function [meanConstErr stdConstErr maxConstErr] = computeConstError(yp,constFunHandle)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

if(iscell(yp))
    yp = cell2mat(yp);
end

meanConstErr = zeros(size(yp,1),1);
stdConstErr = zeros(size(yp,1),1);
maxConstErr = zeros(size(yp,1),1);


for i = 1 : size(yp,1)
    
   
    localErr = abs(constFunHandle(yp(i,:)));    
    
    meanConstErr(i) = mean(localErr);
    stdConstErr(i) = std(localErr);
    maxConstErr(i) = max(localErr);
    
end