function [allModelCs bestModelMVC] = learnConstraintKernelMVCMex(Xlabeled,Xhat,Yhat,numIt,myKern,My,Sy,Y0,constrFunHandle,trainingFunHandle,startV,increamentV)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

Vs = [startV:increamentV:size(Xhat,1),size(Xhat,1)] ;
Vs = unique(Vs);
numVs = length(Vs);
YhatPredictions = Yhat;
allModelCs = cell(numVs,1);
validIndsRest = 1:size(Xhat,1);
numItLocal = ceil(numIt/length(Vs));


for i = 1 : numVs
   
    ces = computeConstError(YhatPredictions(validIndsRest,:),constrFunHandle);               
    [temp temp2] = sort(ces);
    
    if(i>1)
        vinds = [vinds validIndsRest(temp2(1:(Vs(i)-Vs(i-1))))];
    else
        vinds = temp2(1:Vs(1))';
    end
    validIndsRest = setdiff(1:size(Xhat,1),vinds);
          
    fprintf('using %d unlabeled data\n',Vs(i));
    
    XhatIt = Xhat(vinds,:);
    YhatIt = YhatPredictions(vinds,:);
    
    allModelCs{i} = trainingFunHandle(Xlabeled,XhatIt,YhatIt,numItLocal);           
            
    predC = predictConstraintKernel(Xhat,allModelCs{i},myKern,My,Sy);                     
    YhatPredictions = predC + repmat(Y0,size(Xhat,1),1);
       
    allModelCs{i}.CE = mean(computeConstError(YhatPredictions,constrFunHandle));
    
end

minn = 1e10;
for i = 1 : numVs
   if(allModelCs{i}.CE<minn)
       minn = allModelCs{i}.CE;
       bestModelMVC = allModelCs{i};
   end
end

