function [Xall Yall Y Y0 Mesh My Sy dataIndsCell validIndsCell testInds meanX varX] = loadDataPredictions(dataset,numData,numValid,numTests,numTrial,normalizeX)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

% mesh2x2
if(strcmp(dataset,'mesh2x2'))
    Mesh = LoadAndPlotTrig('dat/square2x2',0);
    Yall = load('dat/square_2x2_4000.txt');
    Xall = load('dat/square_2x2_projected_4000.txt');
% quaternion
elseif(strcmp(dataset,'quaternion'))
    Mesh = LoadAndPlotTrig('dat/original_square',0);
    Xall = load('dat/rotated_square_projected_1000_newer.txt');
    Yall = load('dat/rotated_square_quaternions_1000_newer.txt');
    inds = find(Yall(:,1)>0);
    Xall = Xall(inds,:);
    Yall = Yall(inds,:);
else
    error('unknown dataset');
end

Nall = size(Yall,1);
My = zeros(size(Yall,2),1);
Sy = eye(size(Yall,2));

% partition the data into test, labeled and unlabeled sets
[dataIndsCell validIndsCell testInds] = partitionDataRandom(Nall,numData,numValid,numTests,numTrial);

% mean shift
Y0 = zeros(1,size(Yall,2));
Y = Yall - repmat(Y0,Nall,1);

if(normalizeX)
    [Xall meanX varX] = normalizeData(Xall);
else
    meanX = zeros(1,size(Xall,2));
    varX = ones(1,size(Xall,2));
end


