function [dataIndsCell validIndsCell testInds] = partitionDataRandom(Nall,numDatas,numValids,numTests,numTrial)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

randvalues = randperm(Nall);
testInds = randvalues(1:numTests);
trainingInds = setdiff(1:Nall,testInds);

if(length(trainingInds)<max(numDatas)+max(numValids))
    error('not enough training data');
end

dataIndsCell = cell(length(numDatas),1);
for i = 1 : length(numDatas)
    dataIndsCell{i} = zeros(numTrial,numDatas(i));
    for t = 1 : numTrial
        randvalues = randperm(length(trainingInds));
        dataIndsCell{i}(t,:) = trainingInds(randvalues(1:numDatas(i)));
    end
end


validIndsCell = cell(length(numValids),1);
for i = 1 : length(numValids)
    validIndsCell{i} = zeros(numTrial,numValids(i));
  
    for t = 1 : numTrial
        
        allDataIndsForTrial = [];
        for j = 1 : length(numDatas)
            allDataIndsForTrial = [allDataIndsForTrial,dataIndsCell{j}(t,:)];
        end        
        trainingInds2 = setdiff(trainingInds,allDataIndsForTrial);
        
        randvalues = randperm(length(trainingInds2));
        validIndsCell{i}(t,:) = trainingInds2(randvalues(1:numValids(i)));
    end
end