function [Fsum Gsum] = sumConstraints(Y,edges2sum,singleConstrFunHandle)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

if(nargout>1)
    [Fsingle Gsingle]=singleConstrFunHandle(Y);
else
    Fsingle =singleConstrFunHandle(Y);
end

Fsum = zeros(length(edges2sum),1);
if(nargout>1)
    Gsum = zeros(length(edges2sum),length(Y));
end

for i = 1:length(edges2sum)
    Fsum(i) = sum(Fsingle(edges2sum{i}));
    if(nargout>1)
        Gsum(i,:) = sum(Gsingle(edges2sum{i},:));
    end    
end

